package nl.sbdeveloper.mctpaudio.api.events;

import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.jetbrains.annotations.NotNull;

/* Copyright (C) McThemeParks - All Rights Reserved
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 * Written by Stijn Bannink <stijnbannink23@gmail.com>, July 2020
 */

public class AudioConnectionUpdateEvent extends Event implements Cancellable {
    private static final HandlerList handlers = new HandlerList();
    private final Player player;
    private final boolean connected;

    private boolean cancelled = false;

    public AudioConnectionUpdateEvent(@NotNull Player who, boolean connected) {
        super(true);
        this.player = who;
        this.connected = connected;
    }

    public Player getPlayer() {
        return player;
    }

    public boolean isConnected() {
        return connected;
    }

    @NotNull
    @Override
    public HandlerList getHandlers() {
        return handlers;
    }

    @NotNull
    public static HandlerList getHandlerList() {
        return handlers;
    }

    @Override
    public boolean isCancelled() {
        return cancelled;
    }

    @Override
    public void setCancelled(boolean cancelled) {
        if (!isConnected()) return; //Only works if the state is connected.
        this.cancelled = cancelled;
    }
}
